pipeline {
agent any 
environment
{
   image="oussamatayari10/openjdk_spring"
   
   dockerImageP10=""
}

    stages {

stage('git clone')
{
   steps
   {
 git credentialsId: 'jenkins', url: 'git@gitlab.com:oussamatayari10/projet-10-spring.git'
   }
    }
    
  stage('build'){
      steps{
       withMaven(maven: 'maven')
        {  
           sh 'mvn clean install package'
        }
}
   }

stage ('Docker Build')
    {
    steps
    { 
       sh 'docker rmi ${image} || true'
       script
       {
        dockerImageP10 = docker.build(image, ".")
       }
     
                     
    }
    
    }

    stage ('Push  vers DockerHub &Tag')
    {
    environment {
            registryCredential = 'Jenkins_Docker'
        }

       steps {
  
       
       sh 'docker logout || true'
            script { 
                docker.withRegistry( 'https://registry.hub.docker.com', registryCredential ) 
                {
                    dockerImageP10.push("latest")
                    dockerImageP10.push("$BUILD_NUMBER")
                }

     
       }
         
       }
     
    }

    stage(" Deploy to Kubernetes") {
           steps {
withKubeConfig(credentialsId: 'K8S', serverUrl: 'https://3.8.199.131:6443') {
   //sh 'kubectl get po'
    sh 'kubectl delete -f manifest_k8s.yaml || true'
    sh "ssh -o StrictHostKeyChecking=no ubuntu@3.8.199.131 docker rmi oussamatayari10/openjdk_spring || true"
    sh 'kubectl apply -f manifest_k8s.yaml' 
            }



}
 }



    }
}

